import os
import secrets
from flask import Flask, after_this_request, make_response, redirect, request, safe_join, send_from_directory, url_for
from werkzeug.utils import secure_filename


app = Flask(__name__)


with open("/flag.txt", "w") as f:
    f.write(os.getenv("FLAG", "ctf{dummy_flag}"))


@app.route("/", methods=["GET", "POST"])
def gallery():
    if request.method == "POST":
        file = request.files.get("file")
        if file and file.filename:
            filename = secure_filename(file.filename)
            file.save(os.path.join("/uploads/", filename))
            return redirect(f"/login?next=/uploads/{filename}")
    return '''
    <!doctype html>
    <html>
    <head>
        <title>Upload new File</title>
    </head>
    <body>
        <h1>Upload new File</h1>
        <form method="POST" enctype="multipart/form-data">
          <input type="file" name="file" required="required">
          <input type="submit" value="Upload">
        </form>
    </body>
    </html>
    '''


@app.route("/login", methods=["GET", "POST"])
def login():
    @after_this_request
    def add_headers(response):
        # We want to keep any eXtra, non-essential, headers from the original
        # request like X-Forwarded-For, X-PingBack, X-Requested-With, and others
        for key, value in zip(request.args.getlist("headers"), request.args.getlist("values")):
            app.logger.warn(key)
            app.logger.warn(value)
            if not key.startswith("X-"):
                continue
            response.headers[key] = value
        return response
    if request.method == "POST":
        if "next" in request.args:
            return redirect(request.args.get("next"))
    return '''
    <!doctype html>
    <html>
    <head>
        <title>Login</title>
    </head>
    <body>
        <h1>Login</h1>
        <h2>Your file has been uploaded. Login to view it.</h2>
        <form method="POST">
          <label for="username">Username</label>
          <input type="text" id="username" name="username" required="required">
          <label for="password">Password</label>
          <input type="password" id="password" name="password" required="required">
          <input type="submit" value="Login">
        </form>
    </body>
    </html>
    '''


@app.route("/uploads/<path:name>")
def view_upload(name):
    return send_from_directory("/uploads/", name)
